#include <iostream.h>
#include <fstream.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

class CALCULATION{

	public:
	
		int ni;//number of input layer
		int np;//number of teacher's data
		int no;//number of output layer
		int nm;//number of hidden layer
		
		double u0;
		
		double *teacher_input;// ni*np
		double *cal_output;//no*np  ̒lóII
		
		double *input;//ni====input layer
		double *mid;//nm======== hidden layer
		double *output;//no========output layer
		
		double *wim; //ni*nm====weight between input layer and hidden layer
		double *wmo;//no*nm==== weight between output layer and hidden layer
		
		double *biasmid;//nm bias of sigmoid function in hidden layer
		double *biasout;//no bias of sigmoid function in output layer
	
				
		char finname[60];
		char foutname[60];
		char fweightname[60];
		char fcalinfoname[60];
	
				

	double cal(int p)
	{
		int i,j,k;
	
		for (i=0;i<ni;i++) {input[i]=teacher_input[p*ni+i];}
	
		for (j=0;j<nm;j++) {
			mid[j]=Hj(j);
		}
	
		for (k=0;k<no;k++) output[k]=Ok(k);
	
		for (k=0;k<no;k++) cal_output[p*no+k]=output[k];
	
		double error=1;
	
		return error;

	};



	double Hj(int j)
	{
		int i;
		double ans=0.0;
	
		for (i=0;i<ni;i++) ans=ans+input[i]*wim[j*ni+i];
	
		ans=ans+biasmid[j];
	
		return 1/(1+exp(-2*ans/u0));
	};
 
	double Ok(int k) {

		int i;
		double ans=0;
		
		for (i=0;i<nm;i++) ans=ans+mid[i]*wmo[k*nm+i];
		
		ans=ans+biasout[k];
	
		return 1/(1+exp(-2*ans/u0));

	};




	void Learning()
	 {
	int p,iteration=0;
	double /*et=10000*/ep;
		while (iteration < 1) {
			for (p=0;p<np;p++){
				ep=cal(p);//vZ{
			}
			iteration++;
		};
	};

	void kakuho(void) {

		input=new double[ni];
		mid=new double[nm];
		output=new double[no];
	
		wim=new double[ni*nm];//͑wԑwẍ
		wmo=new double[no*nm];//ԑwo͑wẍ
		biasmid=new double[nm];//͑wԑwl̈
		biasout=new double[no];//ԑwo͑wl̈
		teacher_input=new double[ni*np];//͋tf[^̈̊m
		cal_output=new double[no*np];//o̓f[^i[̈̊m

	};


	void kaiho(void) {

		delete input;
		delete mid;
		delete output;
	
		delete wim;//͑wԑwẍ
		delete wmo;//ԑwo͑wẍ
		delete biasmid;//͑wԑwl̈
		delete biasout;//ԑwo͑wl̈
		delete teacher_input;//͋tf[^̈̊J
		delete cal_output;//o̓f[^i[̈̊J

	};


	void kozo(char fconfname[60]) {

		ifstream configin;
		configin.open(fconfname);
		if (!configin){
			cout <<"VXeG[F";
			cout <<fconfname;
			cout <<" J܂łB\n";
			exit(1);
		}
	
		configin >>np;//f[^̓
		configin >>ni;//͑wjbg̓
		configin >>nm;//ԑwjbg̓
		configin >>no;//o͑wjbg̓
		configin >>finname;//̓f[^t@Cǂݍ
		configin >>fweightname;//xi[t@Cǂݍ
		configin >>foutname;//vZʏo̓t@Cǂݍ
		configin >>fcalinfoname;//vZi[t@Cǂݍ
		configin >>u0;//iVOCh̕̕ExHHiʏ1.0jj
		
		ofstream netinf(fcalinfoname);

		netinf <<"\n|||||擾f|||||\n\n";
		netinf <<"\tf[^F";
		netinf <<np;
		netinf <<"\n\n";
		netinf <<"\t͑wjbgF";
		netinf <<ni;
		netinf <<"\n";
		netinf <<"\tԑwjbgF";
		netinf <<nm;
		netinf <<"\n";
		netinf <<"\to͑wjbgF";
		netinf <<no;
		netinf <<"\n\n";
		netinf <<"\t̓f[^t@CF";
		netinf <<finname;
		netinf <<"\n";
		netinf <<"\txi[t@CF";
		netinf <<fweightname;
		netinf <<"\n";
		netinf <<"\tvZʏo̓t@CF";
		netinf <<foutname;
		netinf <<"\n\n";
		netinf <<"\n|||||vZp[^|||||\n\n";
		netinf <<"\txF";
		netinf <<u0;
		netinf <<"\n\n";

		netinf.close();

	};


	void weightread(void) {

		int i;
		double r;
	
		ifstream fin(fweightname);	

		/* ͑w  ԑw ̌x擾 */
		for (i=0;i<(ni*nm);i++) {
			fin >>r;//RRœǂݍ
			wim[i]=r;
		}
		for (i=0;i<nm;i++){
			fin >>r;//l̓RRœǂݍ
			biasmid[i]=r;
		}
		/* ͑w  ԑw ̌x擾܂ */
	

		/* ԑw  o͑w ̌x擾 */
		for (i=0;i<(no*nm);i++) {
			fin >>r;//RRœǂݍ
			wmo[i]=r;
		}
		for (i=0;i<no;i++){
			fin >>r;//l̓RRœǂݍ
			biasout[i]=r;
		}
		/* ͑w  ԑw ̌x擾܂ */

	};


	void readfile(void) {

		int i;
		double r;
	
		ifstream fin(finname);
		for (i=0;i<(ni*np);i++){
		
			fin >>r;
			teacher_input[i]=r;
		}

	};


	void outputcaldata(void) {

		int i,j;
		ofstream fout(foutname);

		/*@vZʏó@*/
		for (i=0;i<np;i++){
			for (j=0;j<no;j++){
				fout <<cal_output[i*no+j];
				if (j==no-1)
					fout <<"\n";
				else
					fout <<"\t";
			}
		}
		/*@vZʏo͂܂Ł@*/

		fout.close();
	};

};

